freedombone-app-matrix 23KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # matrix server
  12. #
  13. # https://raw.githubusercontent.com/silvio/docker-matrix
  14. #
  15. # License
  16. # =======
  17. #
  18. # Copyright (C) 2016 Bob Mottram <bob@freedombone.net>
  19. #
  20. # This program is free software: you can redistribute it and/or modify
  21. # it under the terms of the GNU Affero General Public License as published by
  22. # the Free Software Foundation, either version 3 of the License, or
  23. # (at your option) any later version.
  24. #
  25. # This program is distributed in the hope that it will be useful,
  26. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  27. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  28. # GNU Affero General Public License for more details.
  29. #
  30. # You should have received a copy of the GNU Affero General Public License
  31. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  32. VARIANTS='full full-vim chat'
  33. IN_DEFAULT_INSTALL=0
  34. SHOW_ON_ABOUT=1
  35. MATRIX_DATA_DIR='/var/lib/matrix'
  36. MATRIX_PORT=8448
  37. MATRIX_ID_PORT=8081
  38. MATRIX_REPO="https://github.com/matrix-org/synapse"
  39. MATRIX_COMMIT='f5a4001bb116c468cc5e8e0ae04a1c570e2cb171'
  40. SYDENT_REPO="https://github.com/matrix-org/sydent"
  41. SYDENT_COMMIT='99edbd4c80c42b76e26f696054fcbbceecb25d5f'
  42. REPORT_STATS="no"
  43. MATRIX_SECRET=
  44. matrix_variables=(ONION_ONLY
  45. MY_USERNAME
  46. MATRIX_SECRET
  47. DEFAULT_DOMAIN_NAME)
  48. function matrix_nginx {
  49. matrix_identityserver_proxy_str=' \
  50. location /matrixid { \
  51. proxy_pass http://localhost:8081; \
  52. proxy_buffering on; \
  53. }'
  54. matrix_proxy_str=' \
  55. location /matrix { \
  56. proxy_pass https://localhost:8448; \
  57. proxy_buffering on; \
  58. }'
  59. turn_proxy_str=' \
  60. location /turn { \
  61. proxy_pass https://localhost:3478; \
  62. proxy_buffering on; \
  63. }'
  64. if [[ $ONION_ONLY != 'no' ]]; then
  65. matrix_proxy_str=' \
  66. location /matrix { \
  67. proxy_pass http://localhost:8448; \
  68. proxy_buffering on; \
  69. }'
  70. turn_proxy_str=' \
  71. location /turn { \
  72. proxy_pass http://localhost:3478; \
  73. proxy_buffering on; \
  74. }'
  75. fi
  76. if [ ! -f /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME} ]; then
  77. matrix_nginx_site=/etc/nginx/sites-available/$DEFAULT_DOMAIN_NAME
  78. if [[ $ONION_ONLY == "no" ]]; then
  79. function_check nginx_http_redirect
  80. nginx_http_redirect $DEFAULT_DOMAIN_NAME
  81. echo 'server {' >> $matrix_nginx_site
  82. echo ' listen 443 ssl;' >> $matrix_nginx_site
  83. echo ' listen [::]:443 ssl;' >> $matrix_nginx_site
  84. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  85. echo '' >> $matrix_nginx_site
  86. echo ' # Security' >> $matrix_nginx_site
  87. function_check nginx_ssl
  88. nginx_ssl $DEFAULT_DOMAIN_NAME
  89. function_check nginx_disable_sniffing
  90. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  91. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $matrix_nginx_site
  92. echo '' >> $matrix_nginx_site
  93. echo ' # Logs' >> $matrix_nginx_site
  94. echo ' access_log /dev/null;' >> $matrix_nginx_site
  95. echo ' error_log /dev/null;' >> $matrix_nginx_site
  96. echo '' >> $matrix_nginx_site
  97. echo ' # Root' >> $matrix_nginx_site
  98. echo " root /var/www/$DEFAULT_DOMAIN_NAME/htdocs;" >> $matrix_nginx_site
  99. echo '' >> $matrix_nginx_site
  100. echo ' # Index' >> $matrix_nginx_site
  101. echo ' index index.html;' >> $matrix_nginx_site
  102. echo '' >> $matrix_nginx_site
  103. echo ' # Location' >> $matrix_nginx_site
  104. echo ' location / {' >> $matrix_nginx_site
  105. function_check nginx_limits
  106. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  107. echo ' }' >> $matrix_nginx_site
  108. echo '' >> $matrix_nginx_site
  109. echo ' # Restrict access that is unnecessary anyway' >> $matrix_nginx_site
  110. echo ' location ~ /\.(ht|git) {' >> $matrix_nginx_site
  111. echo ' deny all;' >> $matrix_nginx_site
  112. echo ' }' >> $matrix_nginx_site
  113. echo '}' >> $matrix_nginx_site
  114. else
  115. echo -n '' > $matrix_nginx_site
  116. fi
  117. echo 'server {' >> $matrix_nginx_site
  118. echo " listen 127.0.0.1:$MATRIX_PORT default_server;" >> $matrix_nginx_site
  119. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  120. echo '' >> $matrix_nginx_site
  121. function_check nginx_disable_sniffing
  122. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  123. echo '' >> $matrix_nginx_site
  124. echo ' # Logs' >> $matrix_nginx_site
  125. echo ' access_log /dev/null;' >> $matrix_nginx_site
  126. echo ' error_log /dev/null;' >> $matrix_nginx_site
  127. echo '' >> $matrix_nginx_site
  128. echo ' # Root' >> $matrix_nginx_site
  129. echo " root /var/www/$DEFAULT_DOMAIN_NAME/htdocs;" >> $matrix_nginx_site
  130. echo '' >> $matrix_nginx_site
  131. echo ' # Location' >> $matrix_nginx_site
  132. echo ' location / {' >> $matrix_nginx_site
  133. function_check nginx_limits
  134. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  135. echo ' }' >> $matrix_nginx_site
  136. echo '' >> $matrix_nginx_site
  137. echo ' # Restrict access that is unnecessary anyway' >> $matrix_nginx_site
  138. echo ' location ~ /\.(ht|git) {' >> $matrix_nginx_site
  139. echo ' deny all;' >> $matrix_nginx_site
  140. echo ' }' >> $matrix_nginx_site
  141. echo '}' >> $matrix_nginx_site
  142. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  143. function_check create_site_certificate
  144. create_site_certificate $DEFAULT_DOMAIN_NAME 'yes'
  145. fi
  146. nginx_ensite $DEFAULT_DOMAIN_NAME
  147. fi
  148. if ! grep "localhost:${MATRIX_ID_PORT}" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  149. sed -i "s|:443 ssl;|:443 ssl;${matrix_identityserver_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  150. sed -i "s| default_server;| default_server;${matrix_identityserver_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  151. fi
  152. if ! grep "localhost:${MATRIX_PORT}" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  153. sed -i "s|:443 ssl;|:443 ssl;${matrix_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  154. sed -i "s| default_server;| default_server;${matrix_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  155. fi
  156. if ! grep "localhost:${TURN_PORT}" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  157. sed -i "s|:443 ssl;|:443 ssl;${turn_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  158. sed -i "s| default_server;| default_server;${turn_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  159. fi
  160. systemctl restart nginx
  161. # wait for nginx to start otherwise user add fails later
  162. sleep 5
  163. }
  164. function matrix_generate_homeserver_file {
  165. local filepath="${1}"
  166. cd /etc/matrix
  167. python -m synapse.app.homeserver \
  168. --config-path "${filepath}" \
  169. --generate-config \
  170. --report-stats ${REPORT_STATS} \
  171. --server-name ${DEFAULT_DOMAIN_NAME}
  172. }
  173. function matrix_generate_identityserver_file {
  174. local filepath="${1}"
  175. cd /etc/sydent
  176. python -m sydent.sydent \
  177. --config-path "${filepath}" \
  178. --generate-config \
  179. --report-stats ${REPORT_STATS} \
  180. --server-name ${DEFAULT_DOMAIN_NAME}
  181. }
  182. function matrix_configure_homeserver_yaml {
  183. local turnkey="${1}"
  184. local filepath="${2}"
  185. local ymltemp="$(mktemp)"
  186. awk -v TURNURIES="turn_uris: [\"turn:${DEFAULT_DOMAIN_NAME}/turn?transport=udp\", \"turn:${DEFAULT_DOMAIN_NAME}/turn?transport=tcp\"]" \
  187. -v TURNSHAREDSECRET="turn_shared_secret: \"${turnkey}\"" \
  188. -v PIDFILE="pid_file: ${MATRIX_DATA_DIR}/homeserver.pid" \
  189. -v DATABASE="database: \"${MATRIX_DATA_DIR}/homeserver.db\"" \
  190. -v LOGFILE="log_file: \"/dev/null\"" \
  191. -v MEDIASTORE="media_store_path: \"${MATRIX_DATA_DIR}/media_store\"" \
  192. '{
  193. sub(/turn_shared_secret: "YOUR_SHARED_SECRET"/, TURNSHAREDSECRET);
  194. sub(/turn_uris: \[\]/, TURNURIES);
  195. sub(/pid_file: \/homeserver.pid/, PIDFILE);
  196. sub(/database: "\/homeserver.db"/, DATABASE);
  197. sub(/log_file: "\/homeserver.log"/, LOGFILE);
  198. sub(/media_store_path: "\/media_store"/, MEDIASTORE);
  199. print;
  200. }' "${filepath}" > "${ymltemp}"
  201. mv ${ymltemp} "${filepath}"
  202. if [[ $ONION_ONLY != 'no' ]]; then
  203. sed -i 's|no_tls: .*|no_tls: True|g' "${filepath}"
  204. fi
  205. sed -i 's|enable_registration_captcha.*|enable_registration_captcha: False|g' "${filepath}"
  206. sed -i "s|database: \".*|database: \"${MATRIX_DATA_DIR}/homeserver.db\"|g" "${filepath}"
  207. sed -i "s|media_store_path:.*|media_store_path: \"${MATRIX_DATA_DIR}/media_store\"|g" "${filepath}"
  208. sed -i "s|pid_file:.*|pid_file: \"${MATRIX_DATA_DIR}/homeserver.pid\"|g" "${filepath}"
  209. sed -i "s|log_file:.*|log_file: \"/dev/null\"|g" "${filepath}"
  210. }
  211. function matrix_configure_identityserver {
  212. local filepath=/etc/sydent/sydent.conf
  213. sed -i "s|http.port.*|http.port = $MATRIX_ID_PORT|g" ${filepath}
  214. sed -i "s|db.file.*|db.file = /etc/sydent/sydent.db|g" ${filepath}
  215. sed -i "s|Sydent Validation|Freedombone Matrix Account Validation|g" ${filepath}
  216. sed -i "s|pidfile.path.*|pidfile.path = /etc/sydent/sydent.pid|g" ${filepath}
  217. sed -i "s|log.path.*|log.path = /dev/null|g" ${filepath}
  218. sed -i "s|server.name.*|server.name = ${DEFAULT_DOMAIN_NAME}|g" ${filepath}
  219. }
  220. function matrix_diff {
  221. DIFFPARAMS="${DIFFPARAMS:-Naur}"
  222. DEFAULT_DOMAIN_NAME="${DEFAULT_DOMAIN_NAME:-demo_server_name}"
  223. REPORT_STATS="${REPORT_STATS:-no_or_yes}"
  224. export DEFAULT_DOMAIN_NAME REPORT_STATS
  225. matrix_generate_synapse_file $INSTALL_DIR/homeserver.synapse.yaml
  226. diff -${DIFFPARAMS} $INSTALL_DIR/homeserver.synapse.yaml ${MATRIX_DATA_DIR}/homeserver.yaml
  227. rm $INSTALL_DIR/homeserver.synapse.yaml
  228. }
  229. function matrix_generate {
  230. breakup="0"
  231. [[ -z "${DEFAULT_DOMAIN_NAME}" ]] && echo "STOP! environment variable DEFAULT_DOMAIN_NAME must be set" && breakup="1"
  232. [[ -z "${REPORT_STATS}" ]] && echo "STOP! environment variable REPORT_STATS must be set to 'no' or 'yes'" && breakup="1"
  233. [[ "${breakup}" == "1" ]] && exit 1
  234. [[ "${REPORT_STATS}" != "yes" ]] && [[ "${REPORT_STATS}" != "no" ]] && \
  235. echo "STOP! REPORT_STATS needs to be 'no' or 'yes'" && breakup="1"
  236. homeserver_config=${MATRIX_DATA_DIR}/homeserver.yaml
  237. if [ -f $homeserver_config ]; then
  238. rm $homeserver_config
  239. fi
  240. matrix_generate_homeserver_file $homeserver_config
  241. matrix_configure_homeserver_yaml "${turnkey}" $homeserver_config
  242. }
  243. function remove_user_matrix {
  244. remove_username="$1"
  245. ${PROJECT_NAME}-pass -u $remove_username --rmapp matrix
  246. # TODO: There is no user removal script within synapse
  247. }
  248. function add_user_matrix {
  249. new_username="$1"
  250. new_user_password="$2"
  251. ${PROJECT_NAME}-pass -u $new_username -a matrix -p "$new_user_password"
  252. matrix_nginx
  253. retval=$(register_new_matrix_user -c ${MATRIX_DATA_DIR}/homeserver.yaml -u "${new_username}" -p "${new_user_password}" -a)
  254. echo "0"
  255. }
  256. function install_interactive_matrix {
  257. APP_INSTALLED=1
  258. }
  259. function change_password_matrix {
  260. curr_username="$1"
  261. new_user_password="$2"
  262. #${PROJECT_NAME}-pass -u "$curr_username" -a matrix -p "$new_user_password"
  263. }
  264. function reconfigure_matrix {
  265. echo -n ''
  266. }
  267. function upgrade_matrix {
  268. function_check set_repo_commit
  269. set_repo_commit /etc/matrix "matrix commit" "$MATRIX_COMMIT" $MATRIX_REPO
  270. pip install --upgrade --process-dependency-links .
  271. chown -R matrix:matrix /etc/matrix
  272. chown -R matrix:matrix $MATRIX_DATA_DIR
  273. }
  274. function backup_local_matrix {
  275. source_directory=/etc/matrix
  276. if [ -d $source_directory ]; then
  277. systemctl stop matrix
  278. function_check backup_directory_to_usb
  279. backup_directory_to_usb $source_directory matrix
  280. source_directory=$MATRIX_DATA_DIR
  281. if [ -d $source_directory ]; then
  282. backup_directory_to_usb $source_directory matrixdata
  283. fi
  284. systemctl start matrix
  285. fi
  286. }
  287. function restore_local_matrix {
  288. if [ -d /etc/matrix ]; then
  289. systemctl stop matrix
  290. temp_restore_dir=/root/tempmatrix
  291. function_check restore_directory_from_usb
  292. restore_directory_from_usb $temp_restore_dir matrix
  293. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  294. if [ ! "$?" = "0" ]; then
  295. function_check backup_unmount_drive
  296. backup_unmount_drive
  297. exit 3783
  298. fi
  299. rm -rf $temp_restore_dir
  300. chown -R matrix:matrix /etc/matrix
  301. temp_restore_dir=/root/tempmatrixdata
  302. restore_directory_from_usb $temp_restore_dir matrixdata
  303. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  304. if [ ! "$?" = "0" ]; then
  305. function_check backup_unmount_drive
  306. backup_unmount_drive
  307. exit 78352
  308. fi
  309. rm -rf $temp_restore_dir
  310. chown -R matrix:matrix $MATRIX_DATA_DIR
  311. systemctl start matrix
  312. fi
  313. }
  314. function backup_remote_matrix {
  315. source_directory=/etc/matrix
  316. if [ -d $source_directory ]; then
  317. systemctl stop matrix
  318. function_check backup_directory_to_friend
  319. backup_directory_to_friend $source_directory matrix
  320. source_directory=$MATRIX_DATA_DIR
  321. if [ -d $source_directory ]; then
  322. backup_directory_to_friend $source_directory matrixdata
  323. fi
  324. systemctl start matrix
  325. fi
  326. }
  327. function restore_remote_matrix {
  328. if [ -d /etc/matrix ]; then
  329. systemctl stop matrix
  330. temp_restore_dir=/root/tempmatrix
  331. function_check restore_directory_from_friend
  332. restore_directory_from_friend $temp_restore_dir matrix
  333. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  334. if [ ! "$?" = "0" ]; then
  335. exit 38935
  336. fi
  337. rm -rf $temp_restore_dir
  338. chown -R matrix:matrix /etc/matrix
  339. temp_restore_dir=/root/tempmatrixdata
  340. restore_directory_from_friend $temp_restore_dir matrixdata
  341. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  342. if [ ! "$?" = "0" ]; then
  343. exit 60923
  344. fi
  345. rm -rf $temp_restore_dir
  346. chown -R matrix:matrix $MATRIX_DATA_DIR
  347. systemctl start matrix
  348. fi
  349. }
  350. function remove_matrix {
  351. firewall_remove ${MATRIX_PORT}
  352. systemctl stop matrix
  353. systemctl stop sydent
  354. function_check remove_turn
  355. remove_turn
  356. systemctl disable matrix
  357. systemctl disable sydent
  358. if [ -f /etc/systemd/system/matrix.service ]; then
  359. rm /etc/systemd/system/matrix.service
  360. fi
  361. if [ -f /etc/systemd/system/sydent.service ]; then
  362. rm /etc/systemd/system/sydent.service
  363. fi
  364. apt-get -y remove --purge coturn
  365. cd /etc/matrix
  366. pip uninstall .
  367. cd /etc/sydent
  368. pip uninstall .
  369. rm -rf $MATRIX_DATA_DIR
  370. rm -rf /etc/matrix
  371. rm -rf /etc/sydent
  372. deluser matrix
  373. delgroup matrix
  374. remove_onion_service matrix ${MATRIX_PORT}
  375. sed -i "/location \/matrix {/,/}/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  376. sed -i "/location \/matrixid {/,/}/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  377. sed -i "/location \/turn {/,/}/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  378. systemctl restart nginx
  379. remove_completion_param install_matrix
  380. sed -i '/matrix/d' $COMPLETION_FILE
  381. }
  382. function install_identity_server {
  383. if [ ! -d /etc/sydent ]; then
  384. function_check git_clone
  385. git_clone $SYDENT_REPO /etc/sydent
  386. if [ ! -d /etc/sydent ]; then
  387. echo $'Unable to clone sydent repo'
  388. exit 936525
  389. fi
  390. fi
  391. cd /etc/sydent
  392. git checkout $SYDENT_COMMIT -b $SYDENT_COMMIT
  393. set_completion_param "sydent commit" "$SYDENT_COMMIT"
  394. if [ ! -d $INSTALL_DIR/sydent ]; then
  395. mkdir -p $INSTALL_DIR/sydent
  396. fi
  397. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/sydent
  398. if [ ! "$?" = "0" ]; then
  399. echo $'Failed to install matrix identity server'
  400. exit 798362
  401. fi
  402. function_check matrix_generate_identityserver_file
  403. matrix_generate_identityserver_file /etc/sydent/sydent.conf
  404. if [ ! -f /etc/sydent/sydent.conf ]; then
  405. echo $'Matrix identity server configuration not generated'
  406. exit 72528
  407. fi
  408. function_check matrix_configure_identityserver
  409. matrix_configure_identityserver
  410. if [ ! -f /etc/sydent/sydent.conf ]; then
  411. echo $'Matrix identity server config was not generated'
  412. exit 82352
  413. fi
  414. chmod -R 700 /etc/sydent/sydent.conf
  415. chown -R matrix:matrix /etc/sydent
  416. echo '[Unit]' > /etc/systemd/system/sydent.service
  417. echo 'Description=Sydent Matrix identity server' >> /etc/systemd/system/sydent.service
  418. echo 'After=network.target nginx.target' >> /etc/systemd/system/sydent.service
  419. echo '' >> /etc/systemd/system/sydent.service
  420. echo '[Service]' >> /etc/systemd/system/sydent.service
  421. echo 'Type=simple' >> /etc/systemd/system/sydent.service
  422. echo 'User=matrix' >> /etc/systemd/system/sydent.service
  423. echo "WorkingDirectory=/etc/sydent" >> /etc/systemd/system/sydent.service
  424. echo "ExecStart=/usr/bin/python -m sydent.sydent --config-path /etc/sydent/sydent.conf" >> /etc/systemd/system/sydent.service
  425. echo 'Restart=always' >> /etc/systemd/system/sydent.service
  426. echo 'RestartSec=10' >> /etc/systemd/system/sydent.service
  427. echo '' >> /etc/systemd/system/sydent.service
  428. echo '[Install]' >> /etc/systemd/system/sydent.service
  429. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/sydent.service
  430. systemctl enable sydent
  431. systemctl daemon-reload
  432. systemctl start sydent
  433. if [ ! -f /etc/sydent/sydent.db ]; then
  434. echo $'No matrix identity server database was created'
  435. exit 7354383
  436. fi
  437. chmod -R 700 /etc/sydent/sydent.db
  438. }
  439. function install_home_server {
  440. if [ ! -d /etc/matrix ]; then
  441. function_check git_clone
  442. git_clone $MATRIX_REPO /etc/matrix
  443. if [ ! -d /etc/matrix ]; then
  444. echo $'Unable to clone matrix repo'
  445. exit 6724683
  446. fi
  447. fi
  448. cd /etc/matrix
  449. git checkout $MATRIX_COMMIT -b $MATRIX_COMMIT
  450. set_completion_param "matrix commit" "$MATRIX_COMMIT"
  451. if [ ! -d $INSTALL_DIR/matrix ]; then
  452. mkdir -p $INSTALL_DIR/matrix
  453. fi
  454. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/matrix
  455. if [ ! "$?" = "0" ]; then
  456. echo $'Failed to install matrix home server'
  457. exit 782542
  458. fi
  459. if [ ! -d $MATRIX_DATA_DIR ]; then
  460. mkdir $MATRIX_DATA_DIR
  461. fi
  462. groupadd matrix
  463. useradd -c "Matrix system account" -d $MATRIX_DATA_DIR -m -r -g matrix matrix
  464. function_check install_turn
  465. install_turn
  466. MATRIX_SECRET="${turnkey}"
  467. function_check matrix_generate
  468. matrix_generate
  469. if [[ -z ${MATRIX_DATA_DIR}/homeserver.yaml ]]; then
  470. echo $'homeserver.yaml is zero size'
  471. exit 783724
  472. fi
  473. chmod -R 700 $MATRIX_DATA_DIR/homeserver.yaml
  474. chown -R matrix:matrix /etc/matrix
  475. chown -R matrix:matrix $MATRIX_DATA_DIR
  476. echo '[Unit]' > /etc/systemd/system/matrix.service
  477. echo 'Description=Synapse Matrix homeserver' >> /etc/systemd/system/matrix.service
  478. echo 'After=network.target nginx.target' >> /etc/systemd/system/matrix.service
  479. echo '' >> /etc/systemd/system/matrix.service
  480. echo '[Service]' >> /etc/systemd/system/matrix.service
  481. echo 'Type=simple' >> /etc/systemd/system/matrix.service
  482. echo 'User=matrix' >> /etc/systemd/system/matrix.service
  483. echo "WorkingDirectory=/etc/matrix" >> /etc/systemd/system/matrix.service
  484. echo "ExecStart=/usr/bin/python -m synapse.app.homeserver --config-path ${MATRIX_DATA_DIR}/homeserver.yaml" >> /etc/systemd/system/matrix.service
  485. echo 'Restart=always' >> /etc/systemd/system/matrix.service
  486. echo 'RestartSec=10' >> /etc/systemd/system/matrix.service
  487. echo '' >> /etc/systemd/system/matrix.service
  488. echo '[Install]' >> /etc/systemd/system/matrix.service
  489. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/matrix.service
  490. systemctl enable matrix
  491. systemctl daemon-reload
  492. systemctl start matrix
  493. if [ ! -f $MATRIX_DATA_DIR/homeserver.db ]; then
  494. echo $'No matrix home server database was created'
  495. fi
  496. chmod -R 700 $MATRIX_DATA_DIR/homeserver.db
  497. firewall_add matrix ${MATRIX_PORT}
  498. MATRIX_ONION_HOSTNAME=$(add_onion_service matrix ${MATRIX_PORT} ${MATRIX_PORT})
  499. if [ ! ${MATRIX_PASSWORD} ]; then
  500. if [ -f ${IMAGE_PASSWORD_FILE} ]; then
  501. MATRIX_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  502. else
  503. MATRIX_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  504. fi
  505. fi
  506. rm -rf ${MATRIX_DATA_DIR}/Maildir
  507. rm -rf ${MATRIX_DATA_DIR}/.mutt
  508. rm -f ${MATRIX_DATA_DIR}/.muttrc
  509. rm -f ${MATRIX_DATA_DIR}/.mutt-alias
  510. rm -f ${MATRIX_DATA_DIR}/.procmailrc
  511. rm -f ${MATRIX_DATA_DIR}/.emacs-mutt
  512. }
  513. function install_matrix {
  514. if [ ! -d $INSTALL_DIR ]; then
  515. mkdir -p $INSTALL_DIR
  516. fi
  517. if [[ ${ONION_ONLY} == 'no' ]]; then
  518. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  519. echo $'Obtaining certificate for the main domain'
  520. create_site_certificate ${DEFAULT_DOMAIN_NAME} 'yes'
  521. fi
  522. fi
  523. export DEBIAN_FRONTEND=noninteractive
  524. apt-get -yq install coreutils \
  525. curl file gcc git libevent-2.0-5 \
  526. libevent-dev libffi-dev libffi6 \
  527. libgnutls28-dev libjpeg62-turbo \
  528. libjpeg62-turbo-dev libldap-2.4-2 \
  529. libldap2-dev libsasl2-dev \
  530. libsqlite3-dev libssl-dev \
  531. libssl1.0.0 libtool libxml2 \
  532. libxml2-dev libxslt1-dev libxslt1.1 \
  533. make python python-dev \
  534. python-pip python-psycopg2 \
  535. python-virtualenv sqlite unzip \
  536. zlib1g zlib1g-dev
  537. pip install --upgrade pip
  538. pip install --upgrade python-ldap
  539. pip install --upgrade lxml
  540. function_check install_home_server
  541. install_home_server
  542. function_check install_identity_server
  543. install_identity_server
  544. function_check update_default_domain
  545. update_default_domain
  546. function_check matrix_nginx
  547. matrix_nginx
  548. if [[ $(add_user_matrix "${MY_USERNAME}" "${MATRIX_PASSWORD}" | tail -n 1) != "0" ]]; then
  549. echo $'Failed to add matrix admin user';
  550. exit 879352
  551. fi
  552. APP_INSTALLED=1
  553. }